package com.ruoyi.pay.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.ruoyi.pay.domain.bo.PayDayWorkHoursBo;
import com.ruoyi.pay.domain.vo.PayDayWorkHoursVo;
import com.ruoyi.pay.domain.PayDayWorkHours;
import com.ruoyi.pay.mapper.PayDayWorkHoursMapper;
import com.ruoyi.pay.service.IPayDayWorkHoursService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 日工工时Service业务层处理
 *
 * @author ruoyi
 * @date 2025-05-12
 */
@RequiredArgsConstructor
@Service
public class PayDayWorkHoursServiceImpl implements IPayDayWorkHoursService {

    private final PayDayWorkHoursMapper baseMapper;

    /**
     * 查询日工工时
     */
    @Override
    public PayDayWorkHoursVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询日工工时列表
     */
    @Override
    public TableDataInfo<PayDayWorkHoursVo> queryPageList(PayDayWorkHoursBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<PayDayWorkHours> lqw = buildQueryWrapper(bo);
        Page<PayDayWorkHoursVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询日工工时列表
     */
    @Override
    public List<PayDayWorkHoursVo> queryList(PayDayWorkHoursBo bo) {
        LambdaQueryWrapper<PayDayWorkHours> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<PayDayWorkHours> buildQueryWrapper(PayDayWorkHoursBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<PayDayWorkHours> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getTenantId() != null, PayDayWorkHours::getTenantId, bo.getTenantId());
        lqw.eq(bo.getDeptId() != null, PayDayWorkHours::getDeptId, bo.getDeptId());
        lqw.like(StringUtils.isNotBlank(bo.getDeptName()), PayDayWorkHours::getDeptName, bo.getDeptName());
        lqw.eq(bo.getEmployeeId() != null, PayDayWorkHours::getEmployeeId, bo.getEmployeeId());
        lqw.like(StringUtils.isNotBlank(bo.getEmpName()), PayDayWorkHours::getEmpName, bo.getEmpName());
        lqw.eq(bo.getDate() != null, PayDayWorkHours::getDate, bo.getDate());
        lqw.eq(StringUtils.isNotBlank(bo.getDwYearMonth()), PayDayWorkHours::getDwYearMonth, bo.getDwYearMonth());
        lqw.eq(StringUtils.isNotBlank(bo.getNote()), PayDayWorkHours::getNote, bo.getNote());
        return lqw;
    }

    /**
     * 新增日工工时
     */
    @Override
    public Boolean insertByBo(PayDayWorkHoursBo bo) {
        PayDayWorkHours add = BeanUtil.toBean(bo, PayDayWorkHours.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改日工工时
     */
    @Override
    public Boolean updateByBo(PayDayWorkHoursBo bo) {
        PayDayWorkHours update = BeanUtil.toBean(bo, PayDayWorkHours.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(PayDayWorkHours entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除日工工时
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
